//----------------------------- MORTGAGE --------------------------------
//                by Carl Paulson      Cognitive Portals
//                 http://members.tripod.com/~SleepyCP/
//                          cpaulson@home.com
//-----------------------------------------------------------------------
//
//  Suggested HTML Input:
/*
      <APPLET code="Mortgage.class" width=350 height=250>
          <param name="BGcolor"   value="magenta">
          <param name="FGcolor"   value="black">

          <CENTER><FONT SIZE=3>{If you can read this, your browser 
          dosen`t support Java.}</FONT><BR>
          <FONT FACE="Helvetica" COLOR="#FF0000" SIZE=7>Mortage  
          Comparison Applet</FONT></CENTER><BR>
      </APPLET>
*/
//    Mortgage Comparison Program
//      Data Used:
//        Points for each loan
//        The Base amount of each loan
//        Simple Yearly interest rate for each loan
//        The Term of each loan
//      Results Calculated:
//        The Monthly payment for each loan
//        The total cost of each loan
//
//-----------------------------------------------------------------------

import java.util.*;
import java.net.*;

import java.awt.event.*;
import java.awt.*;
import java.applet.Applet;

//-----------------------------------------------------------------------

public class Mortgage extends Applet {
 
    private boolean debug  = true ;
    private Color colorBG, colorFG;
    private int switchVar;

    private int    nPay1   =   0,    nPay2   =   0;
    private double DPay1   = 0.0,    DPay2   = 0.0;
    private double Points1 = 0.0,    Points2 = 0.0;
    private double PValue1 = 0.0,    PValue2 = 0.0;
    private double YInt1   = 0.0,    YInt2   = 0.0;
    private double MInt1   = 0.0,    MInt2   = 0.0;
    private double Paym1   = 0.0,    Paym2   = 0.0;
    private double Cost1   = 0.0,    Cost2   = 0.0;

    private Panel setupNorth;
    private Panel setupSouth;
    private Panel setupEast;
    private Panel setupWest;
    private Panel pan;

    private TextField  t1a, t2a, t3a, t4a, t1b, t2b, t3b, t4b;
    private TextField  t5a, t5b, t6a, t6b;
    private Label      L1, L2, L3, L4, L5, L6, L7, L0, L0a, L0b;
    private Button     b1, b2a, b2b;
    private String     s5a, s5b, s6a, s6b;
    private int        iTemp;
    private Integer    ITemp;
    private String     STemp;
    private Double     DTemp;
    private double     dTemp;

//-----------------------------------------------------------------------

    public synchronized void init() {

        colorBG    = getColorParam("BGcolor", "magenta");
        setBackground(colorBG);
        colorFG    = getColorParam("FGcolor", "black");
        setForeground(colorFG);

        setLayout(new BorderLayout(5,5));
        setupNorth = new Panel();
        setupEast  = new Panel();
        setupWest  = new Panel();

        setupSouth = new Panel();
        setupSouth.setFont(new Font("Helvetica",Font.PLAIN,10));
        setupSouth.setLayout(new GridLayout(1,7,10,2));

        pan = new Panel();
        pan.setLayout(new GridLayout(8,3,20,5)); //rows & cols    

        t1a = new TextField(" ",10);
        t1b = new TextField(" ",10);
        t2a = new TextField(" ",10);
        t2b = new TextField(" ",10);
        t3a = new TextField(" ",10);
        t3b = new TextField(" ",10);
        t4a = new TextField(" ",10);
        t4b = new TextField(" ",10);

        t5a = new TextField(" ",10);
        t5b = new TextField(" ",10);
        t6a = new TextField(" ",10);
        t6b = new TextField(" ",10);

        b1  = new Button("Run");
        b2a = new Button(" Reset 1 ");
        b2b = new Button(" Reset 2 ");

        L0  = new Label(new String("Mortage Comparison"));
        L0a = new Label(new String("Loan 1"));
        L0b = new Label(new String("Loan 2"));
        L1  = new Label(new String("Loan     "));
        L2  = new Label(new String("Points   "));
        L3  = new Label(new String("Interest "));
        L4  = new Label(new String("Loan Term"));

        L5  = new Label(new String("Results  "));
        L6  = new Label(new String("Payment  "));
        L7  = new Label(new String("Tot. Cost"));

        STemp = new String(" ");

        //      ---------- Initialize ----------

        PValue1  = PValue2 = 100000.0;
        DTemp    = new Double(PValue1); 
        STemp    = DTemp.toString();
        t1a.setText(STemp);
        t1b.setText(STemp);

        //      ----------

        Points1  = Points2 = 0.0;
        DTemp    = new Double(Points1);
        STemp    = DTemp.toString();
        t2a.setText(STemp);
        t2b.setText(STemp);

        //      ----------

        YInt1    = YInt2  = 4.875;
        MInt1    = MInt2  = YInt1 / 1200.0;
        DTemp    = new Double(YInt1); 
        STemp    = DTemp.toString();
        t3a.setText(STemp);
        t3b.setText(STemp);

        //      ----------

        DPay1   = DPay2   = 30.0;
        nPay1   = nPay2   = 30;
        DTemp   = new Double(DPay1); 
        STemp   = DTemp.toString();
        t4a.setText(STemp);
        t4b.setText(STemp);

        //      ----------

        Paym1   = Paym2   = 0.0;
        Cost1   = Cost2   = 0.0;
        t5a.setText(new String(" "));
        t5b.setText(new String(" "));
        t6a.setText(new String(" "));
        t6b.setText(new String(" "));

        Calculate();
        makeGUI();
    }

// ----------------------------------------------------------------------

    private void Calculate() { 

        double Fac1a, Fac2a, Fac3a, Fac1b, Fac2b, Fac3b;
        double one = 1.0;

        Fac1a = one + MInt1;
        Fac2a = Math.pow(Fac1a,(-12.0*DPay1));
        if (MInt1 > 0.0) Fac3a = (one - Fac2a)/MInt1;
        else {
            STemp = "-------";
            t5a.setText(STemp);
            t6a.setText(STemp);
            return;
        }
        if (Fac3a > 0.0) Paym1 = (PValue1*(one + 0.01*Points1) - Fac2a)/Fac3a;
        else {
            STemp = "-------";
            t5a.setText(STemp);
            t6a.setText(STemp);
            return;
        }
        DTemp = new Double(Paym1);
        STemp = DTemp.toString();
        t5a.setText(STemp);    

        Cost1 = 12.0*DPay1*Paym1 - PValue1;
        DTemp = new Double(Cost1);
        STemp = DTemp.toString();
        t6a.setText(STemp); 

       // -----

        Fac1b = one + MInt2;
        Fac2b = Math.pow(Fac1b,(-12.0*DPay2));
        if (MInt2 > 0.0) Fac3b = (one - Fac2b)/MInt2;
        else {
            STemp = "-------";
            t5b.setText(STemp);
            t6b.setText(STemp);
            return;
        }
        if (Fac3b > 0.0) Paym2 = (PValue2*(one + 0.01*Points2) - Fac2b)/Fac3b;
        else {
            STemp = "-------";
            t5b.setText(STemp);
            t6b.setText(STemp);
            return;
        }
        DTemp = new Double(Paym2);
        STemp = DTemp.toString();
        t5b.setText(STemp);        

        Cost2 = 12.0*DPay2*Paym2 - PValue2;
        DTemp = new Double(Cost2);
        STemp = DTemp.toString();
        t6b.setText(STemp);   

    }

// ----------------------------------------------------------------------

    protected void makeGUI() {

        setupNorth.setFont(new Font("Helvetica",Font.BOLD,24));
        setupNorth.add(L0);
        add("North", setupNorth);

        setupEast.add(new Label(new String("  ")));
        add("East", setupEast);
        setupWest.add(new Label(new String("  ")));
        add("West", setupWest);


        pan.setFont(new Font("Helvetica",Font.BOLD,12));

        // ---------- Row 0 ---------- Header
        pan.add(new Label(new String(" ")));
        pan.add(L0a);
        pan.add(L0b);
        // ---------- Row 1 ---------- Loan Amount
        pan.add(L1);
        pan.add(t1a);
        pan.add(t1b);
        // ---------- Row 2 ---------- Points
        pan.add(L2);
        pan.add(t2a);
        pan.add(t2b);
        // ---------- Row 3 ---------- Simple Interest
        pan.add(L3);
        pan.add(t3a);
        pan.add(t3b);
        // ---------- Row 4 ---------- Loan Term
        pan.add(L4);
        pan.add(t4a);
        pan.add(t4b);
        // ---------- Row 5 ---------- Results
        pan.add(L5);
        pan.add(new Label(new String(" ")));
        pan.add(new Label(new String(" ")));
        // ---------- Row 6 ---------- Payment
        pan.add(L6);
        pan.add(t5a);
        pan.add(t5b);
        // ---------- Row 7 ---------- Cost
        pan.add(L7);
        pan.add(t6a);
        pan.add(t6b);
        // ----------
        add("Center",pan);
        // ----------
        setupSouth.add(new Label(""));
        setupSouth.add(b1);
        setupSouth.add(new Label(""));
        setupSouth.add(b2a);
        setupSouth.add(new Label(""));
        setupSouth.add(b2b);
        setupSouth.add(new Label(""));

        add("South", setupSouth);

    }

// ----------------------------------------------------------------------

//========================== Program  Control ===========================

    public Mortgage() { }
    public void start() { }
    public void stop() { }
//  public void run() { }

//-----------------------------------------------------------------------

    public boolean action (Event evt, Object arg) {

        if(evt.target.equals(b1)) {

// ---------          Implement calculation routine
// ---------          Check Text Field Values

            try { 
                PValue1 = (double) Float.valueOf(t1a.getText()).floatValue();
            } catch (Exception e) {
                PValue1 = 0.0;
                t1a.setText(new String("0"));
                System.out.println("Exception: Loan Amount 1 reset to 0");
                return false;
            }

            try { 
                PValue2 = (double) Float.valueOf(t1b.getText()).floatValue();
            } catch (Exception e) {
                PValue2 = 0.0;
                t1b.setText(new String("0"));
                System.out.println("Exception: Loan Amount 2 reset to 0");
                return false;
            }

// ---------
            try { 
                Points1 = (double) Float.valueOf(t2a.getText()).floatValue();
            } catch (Exception e) {
                Points1 = 0.0;
                t2a.setText(new String("0"));
                System.out.println("Exception: Points 1 reset to 0");
                return false;
            }

            try { 
                Points2 = (double) Float.valueOf(t2b.getText()).floatValue();
            } catch (Exception e) {
                Points2 = 0.0;
                t2b.setText(new String("0"));
                System.out.println("Exception: Points 2 reset to 0");
                return false;
            }

// ---------
            try { 
                YInt1 = (double) Float.valueOf(t3a.getText()).floatValue();
            } catch (Exception e) {
                YInt1 = 0.0;
                MInt1 = 0.0;
                t3a.setText(new String("0"));
                System.out.println("Exception: Interest 1 reset to 0");
                return false;
            }
            MInt1 = YInt1 / 1200.0;

            try { 
                YInt2 = (double) Float.valueOf(t3b.getText()).floatValue();
            } catch (Exception e) {
                YInt2 = 0.0;
                MInt2 = 0.0;
                t3b.setText(new String("0"));
                System.out.println("Exception: Interest 2 reset to 0");
                return false;
            }
            MInt2 = YInt2 / 1200.0;
// ---------
            try { 
                nPay1  = Integer.parseInt(t4a.getText());
            } catch (Exception e) {
                nPay1  = 0;
                DPay1 = 0.0;
                t4a.setText(new String("0"));
                System.out.println("Exception: Loan Term 1 reset to 0");
                return false;
            }
            DPay1 = (double) nPay1;

           try { 
                nPay2  = Integer.parseInt(t4b.getText());
            } catch (Exception e) {
                nPay2  = 0;
                DPay2 = 0.0;
                t4b.setText(new String("0"));
                System.out.println("Exception: Loan Term 2 reset to 0");
                return false;
            }
            DPay2 = (double) nPay2;

//==========

            Calculate();

// *********

        } else if (evt.target.equals(b2a)) { 
            // implement reset Loan 1 routine
            nPay1   = 0;
            DPay1   = 0.0;
            Points1 = 0.0;
            PValue1 = 0.0;
            YInt1   = 0.0;
            MInt1   = 0.0;

            t1a.setText(new String("0"));
            t2a.setText(new String("0"));
            t3a.setText(new String("0"));
            t4a.setText(new String("0"));

            s5a     = new String("0.0");
            s6a     = new String("0.0");

        } else if (evt.target.equals(b2b)) { 
            // implement reset Loan 2 routine
            nPay2   = 0;
            DPay2   = 0.0;
            Points2 = 0.0;
            PValue2 = 0.0;
            YInt2   = 0.0;
            MInt2   = 0.0;

            t1b.setText(new String("0"));
            t2b.setText(new String("0"));
            t3b.setText(new String("0"));
            t4b.setText(new String("0"));

            s5b     = new String("0.0");
            s6b     = new String("0.0");

        } else return false;
        return true;
    }

// -------------------------- getColor ----------------------------------

    public Color getColorParam(String c, String def_C) {

        Color Color1 = Color.lightGray;      // default color
        if (def_C != null) {
            if      (def_C.equalsIgnoreCase("black"))     Color1 = Color.black;
            else if (def_C.equalsIgnoreCase("blue"))      Color1 = Color.blue;
            else if (def_C.equalsIgnoreCase("cyan"))      Color1 = Color.cyan;
            else if (def_C.equalsIgnoreCase("darkGray"))  Color1 = Color.darkGray;
            else if (def_C.equalsIgnoreCase("gray"))      Color1 = Color.gray;
            else if (def_C.equalsIgnoreCase("green"))     Color1 = Color.green;
            else if (def_C.equalsIgnoreCase("lightGray")) Color1 = Color.lightGray;
            else if (def_C.equalsIgnoreCase("magenta"))   Color1 = Color.magenta;
            else if (def_C.equalsIgnoreCase("orange"))    Color1 = Color.orange;
            else if (def_C.equalsIgnoreCase("pink"))      Color1 = Color.pink;
            else if (def_C.equalsIgnoreCase("red"))       Color1 = Color.red;
            else if (def_C.equalsIgnoreCase("white"))     Color1 = Color.white;
            else if (def_C.equalsIgnoreCase("yellow"))    Color1 = Color.yellow;
        }

        StringTokenizer st;
        String rgbDelim = ":,.";
        String c_str = getParameter(c);
        if (c_str != null) st = new StringTokenizer(c_str, rgbDelim);
        else return Color1;

        if      (c_str.equalsIgnoreCase("black"))     return Color.black;
        else if (c_str.equalsIgnoreCase("blue"))      return Color.blue;
        else if (c_str.equalsIgnoreCase("cyan"))      return Color.cyan;
        else if (c_str.equalsIgnoreCase("darkGray"))  return Color.darkGray;
        else if (c_str.equalsIgnoreCase("gray"))      return Color.gray;
        else if (c_str.equalsIgnoreCase("green"))     return Color.green;
        else if (c_str.equalsIgnoreCase("lightGray")) return Color.lightGray;
        else if (c_str.equalsIgnoreCase("magenta"))   return Color.magenta;
        else if (c_str.equalsIgnoreCase("orange"))    return Color.orange;
        else if (c_str.equalsIgnoreCase("pink"))      return Color.pink;
        else if (c_str.equalsIgnoreCase("red"))       return Color.red;
        else if (c_str.equalsIgnoreCase("white"))     return Color.white;
        else if (c_str.equalsIgnoreCase("yellow"))    return Color.yellow;

        else if (st.countTokens() == 3) {
            Integer r = new Integer(st.nextToken());
            Integer g = new Integer(st.nextToken());
            Integer b = new Integer(st.nextToken());
            Color1    = new Color(r.intValue(), g.intValue(), b.intValue());
            return Color1;
            }
        return Color1;
    }

// ----------------------------------------------------------------------

}

//***********************************************************************
